-- TAD CjtoFinito

module TADCjtoFinito where

-- CONSTRUCTORES

data Eq e => CjtoFinito e = Vacío
                           | Agregar e (CjtoFinito e)
                           deriving Show

-- OPERACIONES

es_vacío :: Eq e => CjtoFinito e -> Bool
está :: Eq e => e -> CjtoFinito e -> Bool
borrar :: Eq e => e -> CjtoFinito e -> CjtoFinito e

-- ECUACIONES

es_vacío Vacío = True
es_vacío (Agregar e d) = False

está e Vacío = False
está e (Agregar e' d) | e == e' = True
                      | otherwise = está e d

borrar e Vacío = Vacío
borrar e (Agregar e' d) | e == e' = borrar e d
                        | otherwise = Agregar e' (borrar e d)

instance Eq e => Eq (CjtoFinito e) where
  Vacío == Vacío = True
  Agregar e d == d' = está e d' && borrar e d == borrar e d'

